% safe zone (vertex 56) is not included
% remove "v_block" from function VerS=FcandiV(v_I,d,v_block,B)
function VerS=FcandiV(v_I,d,B) % d is the distance from the initial vertex
% VerS: the set for vertices in consideration
% d is lookahead steps
% VerS(1,:) the set of possible vertices at t = 1; e.g., (v,0,...,0)
% VerS(2,:) the set of possible vertices at t = 2; etc. 
[Num_V Num_E]=size(B);
VerS=zeros(d+1,Num_V);
VerS(1,1)=v_I;
for i=1:d
    k=1;
    for i1=1:Num_V
        vt=VerS(i,i1);
        if vt==0            
            break;
        else
            if vt~=Num_V
                [Edge,l2]=findneighbor(vt,B);
                v_next=Edge(:,1);
                % Edge(:,1): neighboring vertices;
                % Edge(:,2): edges (indices) corresponding to neighboring
                % vertices
                % l2: the number of Edge(:,1)
                % Add new vertices from {v_next} to {VerS(i+1,:)}
                for i2=1:l2
                    flag=ismember(v_next(i2),VerS(i+1,:));
                    if flag==0
                        VerS(i+1,k)=v_next(i2);
                        k=k+1;
                    end
                end
                %%  add vt itself to VerS(i+1,:)
                flag=ismember(vt,VerS(i+1,:));
                if flag==0
                    VerS(i+1,k)=vt;
                    k=k+1;
                end
            end
        end
    end
end