%B matrix: The layout of the building
% the incidence matrix
B=zeros(24,30);   % B(the passage's  index; the area's index)
B(1,1)=-1;B(2,1)=1;B(2,2)=-1;B(3,2)=1;
B(6,3)=-1;B(3,3)=1;B(4,4)=-1;B(6,4)=1;
B(5,5)=-1;B(4,5)=1;B(7,6)=-1;B(6,6)=1;
B(3,7)=-1;B(12,7)=1;B(12,8)=-1;B(13,8)=1;
B(13,9)=-1;B(24,9)=1;B(12,10)=-1;B(16,10)=1;
B(16,11)=-1;B(13,11)=1;B(8,12)=-1;B(10,12)=1;
B(9,13)=-1;B(10,13)=1;B(10,14)=-1;B(14,14)=1;
B(11,15)=-1;B(16,15)=1;B(15,16)=-1;B(14,16)=1;
B(14,17)=-1;B(16,17)=1;B(16,18)=-1;B(18,18)=1;
B(16,19)=-1;B(19,19)=1;B(16,20)=-1;B(21,20)=1;
B(23,21)=-1;B(16,21)=1;B(17,22)=-1;B(24,22)=1;
B(18,23)=-1;B(17,23)=1;B(18,24)=-1;B(19,24)=1;
B(19,25)=-1;B(20,25)=1;B(23,26)=-1;B(21,26)=1;
B(21,27)=-1;B(22,27)=1;B(23,28)=-1;B(22,28)=1;
B(22,29)=-1;B(24,29)=1;B(20,30)=-1;B(24,30)=1;
%
% the passage (edge) capacity constraits
CapaP=zeros(30,3);
% CapaP(1)=[edge capacity; the average time spent (seconds); familiarity in two directions: consistent with B or not]
CapaP(1,:)=[6 1 0.3];  
CapaP(2,:)=[6 1 0.3]; 
CapaP(3,:)=[12 1 0.3]; 
CapaP(4,:)=[10 1 0.2]; 
CapaP(5,:)=[4 1 0.3]; 
CapaP(6,:)=[5 1 0.3]; 
CapaP(7,:)=[15 2 0.2]; 
CapaP(8,:)=[6 1 0]; 
CapaP(9,:)=[6 1 0.2]; 
CapaP(10,:)=[18 3 0.2]; 
CapaP(11,:)=[6 2 0]; 
CapaP(12,:)=[6 2 0.4]; 
CapaP(13,:)=[5 1 0.4]; 
CapaP(14,:)=[10 1 0.2]; 
CapaP(15,:)=[2 2 0.4]; 
CapaP(16,:)=[10 1 0.3]; 
CapaP(17,:)=[10 2 0.4]; 
CapaP(18,:)=[14 3 0]; 
CapaP(19,:)=[10 2 0.5]; 
CapaP(20,:)=[30 3 -0.2]; 
CapaP(21,:)=[30 3 0.4]; 
CapaP(22,:)=[6 1 0.3]; 
CapaP(23,:)=[14 1 -0.2]; 
CapaP(24,:)=[10 1 0.5]; 
CapaP(25,:)=[10 1 0.5]; 
CapaP(26,:)=[10 2 0.3]; 
CapaP(27,:)=[10 2 0]; 
CapaP(28,:)=[8 2 0]; 
CapaP(29,:)=[6 1 0.3]; 
CapaP(30,:)=[5 1 0.5];
% the room (vertex) capacity constraits
CapaR=zeros(23,1);
% CapaR(1)=[vertex capacity]
CapaR(1)=[37];  
CapaR(2)=[65]; 
CapaR(3)=[81]; 
CapaR(4)=[45]; 
CapaR(5)=[70]; 
CapaR(6)=[40]; 
CapaR(7)=[25]; 
CapaR(8)=[45]; 
CapaR(9)=[38]; 
CapaR(10)=[55]; 
CapaR(11)=[16]; 
CapaR(12)=[190]; 
CapaR(13)=[55]; 
CapaR(14)=[80]; 
CapaR(15)=[60]; 
CapaR(16)=[280]; 
CapaR(17)=[130]; 
CapaR(18)=[120]; 
CapaR(19)=[22]; 
CapaR(20)=[25]; 
CapaR(21)=[240]; 
CapaR(22)=[70]; 
CapaR(23)=[60]; 
% Familiar routes 
% assuming familiarity is not distinguished between individual groups
% familiar exits (and routes) are incorporated in dpsolve.m
%
% Visible routes to an exit 
% If an exit is visible, the corresponding route is a straight line, thus
% the route can be obtained given the exit (Exit 4)
VisibleE=zeros(23,4);
% ExitV =  13    17    22    20
VisibleE(12,:)=[13 0 0 0]; % the visible exit at Vertex 12 
VisibleE(13,:)=[13 0 0 0]; % the visible exit at Vertex 2 
VisibleE(16,:)=[0 0 0 20]; 
VisibleE(17,:)=[0 17 0 0]; 
VisibleE(18,:)=[0 17 0 0]; 
VisibleE(19,:)=[0 0 0 20]; 
VisibleE(20,:)=[0 0 0 20]; 
VisibleE(21,:)=[0 0 22 20]; 
VisibleE(22,:)=[0 0 22 0]; 
VisibleE(23,:)=[0 0 22 20]; 
%%%
% 
VisibleM=zeros(23,23);
VisibleM(1,1)=1;VisibleM(1,2)=1;
VisibleM(2,2)=1;VisibleM(2,3)=1;VisibleM(2,6)=1;
VisibleM(3,3)=1;VisibleM(3,6)=1;VisibleM(3,12)=1;VisibleM(3,16)=1;
VisibleM(4,4)=1;VisibleM(4,5)=1;VisibleM(4,6)=1;
VisibleM(5,5)=1;
VisibleM(6,6)=1;VisibleM(6,7)=1;
VisibleM(7,7)=1;
VisibleM(8,8)=1;VisibleM(8,10)=1;
VisibleM(9,9)=1;VisibleM(9,10)=1;
VisibleM(10,10)=1;VisibleM(10,14)=1;VisibleM(10,16)=1; 
VisibleM(11,11)=1;VisibleM(11,16)=1;
VisibleM(12,12)=1;VisibleM(12,13)=1;VisibleM(12,16)=1; 
VisibleM(13,13)=1;VisibleM(13,16)=1; 
VisibleM(14,14)=1;VisibleM(14,15)=1;VisibleM(14,16)=1;
VisibleM(15,15)=1;
VisibleM(16,16)=1;VisibleM(16,18)=1;VisibleM(16,19)=1;VisibleM(16,21)=1;VisibleM(16,23)=1;
VisibleM(17,17)=1;VisibleM(17,18)=1;
VisibleM(18,18)=1;VisibleM(18,19)=1;
VisibleM(19,19)=1;VisibleM(19,20)=1;
VisibleM(20,20)=1;
VisibleM(21,21)=1;VisibleM(21,22)=1;VisibleM(21,23)=1;
VisibleM(22,22)=1;VisibleM(22,23)=1;
VisibleM(23,23)=1;
VisibleM=VisibleM+VisibleM'-eye(23,23);
%% fire propagation matrix
FireP=zeros(24,24);
FireP=eye(24)+FireP;
%
FireP(1,2)=0.2;FireP(2,3)=0.1;FireP(3,6)=0.2;FireP(4,6)=0.2;
FireP(4,5)=0.2;FireP(6,7)=0.3;FireP(3,12)=0.1;FireP(12,13)=0.1;
FireP(12,16)=0.1;FireP(13,16)=0.05;FireP(8,10)=0.2;FireP(9,10)=0.2;
FireP(10,14)=0.15;FireP(11,9)=0.3;FireP(10,14)=0.3;FireP(11,16)=0.2;
FireP(14,15)=0.2;FireP(14,16)=0.3;FireP(16,21)=0.4;FireP(16,23)=0.3;
FireP(17,18)=0.2;FireP(18,19)=0.3;FireP(19,20)=0.2;FireP(23,21)=0.2;
FireP(21,22)=0.1;FireP(23,22)=0.3;
%
FireP=FireP+FireP'-eye(24); %+ones(24)*0.15;
FireP(24,24)=0;
%
% the risk to stay at vertices 
FireS=ones(23,1)*55;   % based on the summation of risk before rescure
% FireS(1)= 55; FireS(2)=55 ; FireS(3)=55;  
% FireS(4)= 55; FireS(5)= 55 ; FireS(6)=55;  
% FireS(7)= 55; FireS(8)=55 ; FireS(9)=55;  
%%%% Other parameters
T=15;r_c=0.1; % the planning horizon; the constant in risk value
%T_I=6; % the time step is 6 seconds; 
d=3; % the lookahead steps
alpha=0.7;  % the social bonds (cooperativeness)
Blc=0.2; % Blc: the proportion of capacity when blocked (flow rates)
%[C CapaN CapaV N_vex]=NewStru(B,CapaP,CapaR); 
[C CapaN CapaV N_vex]=NewStru(B,CapaP,CapaR);
[BGobj C_N A]=GeAdja(C);      % BGobj is for: [dist,path,pred] = shortestpath(BGobj,1,3,'directed',false,'method','BFS');
[Num_oV Num_oE]=size(B);  % the old structure, before adding the virtual virtices
[Num_V Num_E]=size(C);   % Num_V: the number of vertices; Num_E: the number of edges
x=zeros(Num_V,T+1);
for i=1:Num_oV
    flag = ismember(i,PeoDistr(:,1));
    if flag==1
        for i1=1:rA
            if PeoDistr(i1,1)==i
                break;
            end
        end
        x(i,1)=PeoDistr(i1,2);
    end
end
%
% Assigning Costs for staying at different vertices 
StayC=1000*ones(Num_V,1);
% StayC(2)=0.1; % assigning costs for safe havens 
% Cognitive bias coefficients
% assuming all groups have the same set of coefficients 
% the set for familiarity
% betaR=1 (default)
betaF=1.4;
betaG=2;
betaH=0.5;  
betaB=1;
betaV=0;
betaGV=0; % no interaction effects
betaHV=0; % no interaction effects
betaHS=0; % no interaction effects
% the set for static guidance
% staticG=zeros(Num_E,1);
% % the set for visibility
% VisibleS=zeros(Num_E,1);
% % the set for HerdS
% % HerdS=zeros(Num_E,T);
% betaG=0.7; % cognitive bias caused by guidance 
% betaSG=0.2; % cognitive bias caused by static sign 
% betaH=0.5; % cognitive bias caused by herding
% assuming all groups have the same planning horizon
To=3;
Fami_Vertex=20;Fami_Exit=4;
Zs=0;
% Group 1: at vertex 2, group size: 17 people
% PeoDistr(1,:)=[1,2];
% PeoDistr(2,:)=[1,20];
% PeoDistr(3,:)=[3,20];
% PeoDistr(4,:)=[4,20];
% PeoDistr(5,:)=[5,20];
% PeoDistr(6,:)=[6,20];
% PeoDistr(7,:)=[7,20];
% PeoDistr(8,:)=[8,20];
% PeoDistr(9,:)=[9,20];
% PeoDistr(10,:)=[10,20];
% PeoDistr(11,:)=[11,20];
% PeoDistr(12,:)=[12,20];
%
% Initializing the state of occupants at the beginning  
% PeoDistr(*,1): the vertex that occupants stay
% PeoDistr(*,2): the number of occupants on the vertex 
% x=zeros(Num_V,T+1);
% [num_group xx]=size(PeoDistr);
% for i=1:num_group
%     x(PeoDistr(i,1),1)=PeoDistr(i,2);    
% end