function [Eq_sum qd_sum qdR xS J gap p_pass]=MovPre1(GroupO,routeV,pathV,C,T,CapaN,CapaR,Blc,alpha,Num_oV,risk,Capa_Matrix,lambda_t)
% Eq: the expected flow rates of different groups and different times;
% Lcost: the Lagrangian; GroupO: people's distribution; routeV:
% guidance, CapaN: capacities and familiarity,
% Blc: the proportion of capacity when blocked (flow rates)
[cx N_g1]=size(GroupO);
% cx is the number of groups; N_g1 has no use;
[Num_V Num_E]=size(C);
x=zeros(Num_V,T+1,cx);
qdR=zeros(Num_E,T,cx);
Eq=zeros(Num_E,T,cx);
qd_sum=zeros(Num_E,T);
Eq_sum=zeros(Num_E,T);
p_pass=zeros(Num_E,T);
Dr=ones(Num_E,T); % direction of flow on edges: "1" or "-1"
for i1=1:cx
    locat = GroupO(i1,1); % locat=location
    x(locat,1,i1)=GroupO(i1,2); % the number of people in group i1
end
% assuming every group follows the route suggested by guidance, deriving
% deriving group dynamics/ Evaluating the expected desired flow rate
for i=1:T    % i is the index of time
    % calculate the desired flow rates
    for i2=1:cx
        for i3=1:Num_V
            if pathV(i2,i3)==0
                break;
            else
                locat=routeV(i2,i3);
                edge_N=pathV(i2,i3);           % edge number = pathV();
                qdR(edge_N,i,i2)=x(locat,i,i2);
                if C(locat,edge_N)==1
                    Dr(edge_N,i)=-1; % the opposite direction
                end
            end
        end
    end
    for i2=1:cx
        for i4=1:Num_E
            qd_sum(i4,i)=qd_sum(i4,i)+qdR(i4,i,i2);
        end
    end
    % calculate the expected flow rates
    for i4=1:Num_E
        Capacity=CapaN(i4,1);
        Qd=qd_sum(i4,i);
        if Qd>Capacity
            Eq_sum(i4,i)=(exp(-alpha/(Qd-Capacity)))*Capacity*Blc+(1-exp(-alpha/(Qd-Capacity)))*Capacity;
            p_pass(i4,i)=Eq_sum(i4,i)/qd_sum(i4,i);
        else
            Eq_sum(i4,i)=Qd;
            p_pass(i4,i)=1;
        end
    end
    % update the states for different groups
    for i2=1:cx
        for i3=1:Num_V  % the i3th vertex on the route
            if pathV(i2,i3)==0
                break;
            else
                locat=routeV(i2,i3);
                locat_n=routeV(i2,i3+1);
                edge_N=pathV(i2,i3);
                Eq(edge_N,i,i2)=qdR(edge_N,i,i2)*p_pass(edge_N,i);
                if i3==1
                    x(locat,i+1,i2)=x(locat,i,i2)-Eq(edge_N,i,i2);
                else
                    x(locat,i+1,i2)=x(locat,i+1,i2)-Eq(edge_N,i,i2);
                end
                %%%%%%%%%%%%%%%%%   consider room capacity %%%%%%%%%%
                x(locat_n,i+1,i2)=x(locat_n,i,i2)+Eq(edge_N,i,i2);
                if locat_n<Num_oV
                    if x(locat_n,i+1,i2)>CapaR(locat_n)
                        x(locat_n,i+1,i2)=CapaR(locat_n);
                        Eq_new=CapaR(locat_n)-x(locat_n,i,i2);
                        x(locat,i+1,i2)=x(locat,i+1,i2)+Eq(edge_N,i,i2)-Eq_new;
                        Eq(edge_N,i,i2)=Eq_new;
                    end
                end
            end
        end
    end
end
xS=zeros(Num_V,T+1);
J=0;
for i=1:Num_V
    for j=1:(T+1)
        xS(i,j)=sum(x(i,j,:));
        J=J+xS(i,j)*risk(i,j);
    end
end
gap=sum(sum((Eq_sum-Capa_Matrix).*lambda_t));