% transfer the Incidence matrix into the standard one
function [C CapaN CapaV N_vex]=NewStru(B,CapaP,CapaR)
%
% Add CapaR -> CapaV: room capacities
[Num_V Num_E]=size(B);
n=0;     % counting the total number of vertices/edges to be added
for i=1:Num_E
    NewStates=CapaP(i,2)-1;
    n=n+NewStates;
end
C=zeros((Num_V+n),(Num_E+n));
C((1:Num_V),(1:Num_E))=B; 
CapaN=zeros((Num_E+n),2);    % first column: capacity; second column: familiarity
CapaN(1:Num_E,1)=CapaP(:,1);
CapaN(1:Num_E,2)=CapaP(:,3);
ExtrE=zeros(1,n);   % the extra states from B: Edge indices
n1=0;   % counting the number of edges that needs to be extended
for i=1:Num_E
    if CapaP(i,2)>1
        n1=n1+1;
        ExtrE(n1)=i;  % i is the edge index
    end
end
CapaV=zeros((Num_V+n-1),1); % new capacity (vertices) vector
CapaV(1:(Num_V-1))=CapaR(:,1);  % Capa(Num_V) does not exist: outside building
%
c1=0;
for i=1:n1
    E_index=ExtrE(i); % the indices of long edges 
    [V1 V2]=fVex(B,E_index);
    % V_index=ExtrV(i);
    k=CapaP(E_index,2)-1; % the number of extra vertices on an edge 
    for i1=1:k
        c1=c1+1;   % counter 1: the counter for newly added vertex and edge
        Vex_new=Num_V+c1;
        Edge_new=Num_E+c1;
        % the last vertex (C(Num_V,:)) is not the exit (outside) vertex yet
        C=AddVex(C,E_index,Vex_new,Edge_new);
        CapaN(Edge_new,1)=CapaN(E_index,1);
        CapaN(Edge_new,2)=CapaN(E_index,2);
        %
        % the related old vertices; the related new vertices
        if V2~=Num_V
            CapaV(Vex_new-1)=min(CapaR(V1),CapaR(V2));
        else
            CapaV(Vex_new-1)=CapaR(V1);
        end
    end
end
TT=C((Num_V+1):(Num_V+n),:);    
% exchange rows: to guarantee the last vertex is the exit
C([Num_V;Num_V+n],:)=C([Num_V+n;Num_V],:);
C((Num_V):(Num_V+n-1),:)=TT;
% A([1;3],:)=A([3;1],:)
N_vex=Vupdate(B,n1,C,CapaP,ExtrE);