function [PSuggestR ProbR CostSR CostSB ECostOR ECostOB]=SelectR(v_start,groupIndex,routeV,C,BGobj,ke,RouteInMind,t,To,PCostR,PCostB,betaG,betaH,betaF,betaB,risk,lambdaV_t,lambda_t,CapaN,p_pass,SrouteV,EdgeV, StayC)
%
% Given: RouteInMind: (dimension) ke*(To+1-t): for a single group
% Given: time window: [t,To];
% Given: PCostR, PCostB
% Given: betaG, betaH, betaF, betaB
% Given: R:risk; (dimension)
% Given: lambdaV_t, lambda_t, CapaN, p_pass
% Given: v_start, C, BGobj, ke
% Given: SrouteV, StayC
%
% Output: PSuggestR, CostR on SuggesteR, CostB on SuggesteR, Probability on PSuggestR
% Output: Expected CostR and CostB on other routes
%
%% Given v_start, derive VerS
d= To-t;
VerS=FcandiV(v_start,d,C);
[Num_V Num_E]=size(C);
%
RouteInMindt=reshape(RouteInMind(v_start,:,1:(To+1+6)),[ke,(To+1+6)]);
RouteInMindi=[RouteInMindt(:,1:(d+1)) RouteInMindt(:,(To+2):(To+7))];
%%
Origin=VerS(1,1);
RouteSet=[];
% RouteInMindi: dimension: ke*(d+1): for a single group
% remove zero vectors in RouteInMindi
for i=1:ke
    if RouteInMindi(i,1)~=0
        RouteSet=[RouteSet;RouteInMindi(i,:)];
    end
end
% RrouteV: remaining route Vector: Herding
% RrouteV: the set of (suggested) route vectors of other groups 
[groups col]=size(routeV);
if groups==1
    RrouteV=zeros(1,col); % RrouteV: rest of routeV
else
    if groupIndex==1
        RrouteV=routeV(2:groups,:);
    elseif groupIndex==groups
        RrouteV=routeV(1:(groups-1),:);
    else
        RrouteV=[routeV(1:(groupIndex-1),:);routeV((groupIndex+1):groups,:)];
    end
end
%
% the route used by a group (herding)
% given the movement of all other groups
[Edge k3]=findneighbor(Origin,C);
for i=1:k3
    Neighbor=Edge(i,1);
    a=ismember(RrouteV(:,t+1),Neighbor); % RouteV(1,:) the location of a
    k4=length(a);
    for i1=1:k4
        % if there exists a group moves at Vertex Neighbor
        % the corresponding route is
        % Origin -> Neighbor -> RouteV(i1,2) -> RouteV(i1,3)...
        % Is the above route in "RouteInMindi?"
        if a(i1)~=0
            RouteH=[v_start,RrouteV(i1,(t+1):To)];
            % if RouteH is not included in RouteSet
            if ismember(RouteH,RouteSet(:,(t+1):(To+1)),'rows')==0
                RouteSet=[RouteSet;[RouteH 0 0 0 1 0 0]];
            else % if RouteH is included in RouteSet
                [a1 b]=ismember(RouteH,RouteSet(:,(t+1):(To+1)),'rows');
                RouteSet(b,(d+5))=1; % assign Zh = 1
            end
        end
    end
end
%
%%% Assigning properties: Zb, Zr, J_To (the disutility) on each route
% RouteSet(d+2):Zb
% RouteSet(d+3):Zr
% RouteSet(d+4):Zf
% RouteSet(d+5):Zh
% RouteSet(d+6):Jt
% RouteSet(d+7):Jt_psyc (no guidance)
[Num_route Len_route]=size(RouteSet);
%
for i=1:Num_route
    % deriving Zb and Zr for a (considered) route
    Zb=0;
    Zr=0;
    for i1=1:d
        if RouteSet(i,(i1+1))==0
            break
        else
            if i1<d % if (i1+1) < (d+1)
                Zr=Zr+ risk(RouteSet(i,(i1+1)),(i1+1));
                if RouteSet(i,i1)==RouteSet(i,i1+1)
                    Zb = Zb+lambdaV_t(RouteSet(i,i1+1),i1+1);
                else
                    [EdgeN flag]=EdgeF(RouteSet(i,i1),RouteSet(i,(i1+1)),C);
                    Zb = Zb+lambdaV_t(RouteSet(i,i1+1),(i1+1))+lambda_t(EdgeN,i1);
                end
            else
                Destination=RouteSet(i,(d+1));
                Zb=Zb+PCostB(Destination);
                Zr=Zr+PCostR(Destination);
            end
        end
    end
    Zr=Zr+risk(RouteSet(i,1),1);
    %
    RouteSet(i,(d+2))=Zb;
    RouteSet(i,(d+3))=Zr;
    RouteSet(i,(d+6))=Zb+Zr;
    RouteSet(i,(d+7))=Zb*betaB+Zr-RouteSet(i,(d+4))*betaF-RouteSet(i,(d+5))*betaH;
end
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Deriving expected disutilities of using a route (in RouteSet) that is not suggested by guidance 
% Routes in RouteSets: (1+d) vertices or less 
%[Num_route Len_route]=size(RouteSet);
% derive backwardly; two cases 
% One possible case not included: multiple familiar routes 
EU_setR=zeros(Num_route,1); 
EU_setB=zeros(Num_route,1);
for i=1:Num_route
    % is the route selected because of herding (or Herding + familiarity)? RouteSet(d+5)
    if RouteSet(i,d+5)==1
        % a particular route:  RouteSet(i,1:(1+d))
        % deriving the expected disutility backwardly
        EU_setR(i)=RouteSet(i,(d+3));
        EU_setB(i)=RouteSet(i,(d+2));
        for i1=d:1
            if RouteSet(i,i1)==0
                continue;
            else
                % at RouteSet(i,i1), is there a route better than RouteSet(i)?
                % if there exist such a route, suggest it and calculate prob
                % and expected cost
                %
                % The cost by using the old route
                v_c=RouteSet(i,i1);
                e_c=EdgeF(RouteSet(i,i1),RouteSet(i,(i1+1)),C);
                zr=EU_setR(i)+risk(v_c);
                zb=EU_setB(i)+lambda_t(e_c)+lambdaV_t(v_c);
                % the cost by using a (best) suggested route
                [cB cR OrouteV]=heuriA(RouteSet(i,i1),i1,Num_V,SrouteV,EdgeV,lambdaV_t,lambda_t,ke,risk,StayC);
                PCostB1=cB;
                PCostR1=cR;
                PCost1=cB+cR;   % Cost at t = To+1
                % judge whether OrouteV(1:(To+1-i1)) is identical with the old
                % route: RouteSet(1:(To+1-i1))?= OrouteV(1:(To+1-i1))
                % OrouteV is the suggested route
                flag=ismember(RouteSet(i1:(To+1)),reshape(OrouteV(1:(To+2-i1)),[1,(To+2-i1)]),'rows');
                %
                if (PCost1<(zr+zb))&(flag==0)
                    % there are two routes to be selected: the herding route
                    % and the guidance route
                    Perceive_H=zr+zb*betaB-betaH;
                    Perceive_G=PCostR1+PCostB1*betaB-betaG;
                    % probabilities of selecting a route
                    Pr_route=zeros(Num_route+1,1);
                    U_routeG=exp(-Perceive_G);
                    U_routeH=exp(-Perceive_H);
                    %
                    Pr_routeG=U_routeG/(U_routeH+U_routeG);
                    Pr_routeH=U_routeH/(U_routeH+U_routeG);
                    % expected cost of the route
                    EU_setR(i)=PCostR1*Pr_routeG+zr*Pr_routeH;
                    EU_setB(i)=PCostB1*Pr_routeG+zb*Pr_routeH;
                else
                    % if there does not exist a better route (to be suggested), add (update) the cost
                    % the cost is zr and zb
                    EU_setR(i)=zr;
                    EU_setB(i)=zb;
                end
                %
            end
        end
    else
        % the route selected because of familiarity (only) (or because of visibility)
        %        
                % a particular route:  RouteSet(i,1:(1+d))
        % deriving the expected disutility backwardly
        EU_setR(i)=RouteSet(i,(d+3));
        EU_setB(i)=RouteSet(i,(d+2));
        for i1=d:1
            if RouteSet(i,i1)==0
                continue;
            else
                % at RouteSet(i,i1), is there a route better than RouteSet(i)?
                % if there exist such a route, suggest it and calculate prob
                % and expected cost
                %
                % The cost by using the old route
                v_c=RouteSet(i,i1);
                e_c=EdgeF(RouteSet(i,i1),RouteSet(i,(i1+1)),C);
                zr=EU_setR(i)+risk(v_c);
                zb=EU_setB(i)+lambda_t(e_c)+lambdaV_t(v_c);
                % the cost by using a (best) suggested route
                [cB cR OrouteV]=heuriA(RouteSet(i,i1),i1,Num_V,SrouteV,EdgeV,lambdaV_t,lambda_t,ke,risk,StayC);
                PCostB1=cB;
                PCostR1=cR;
                PCost1=cB+cR;   % Cost at t = To+1
                % judge whether OrouteV(1:(To+1-i1)) is identical with the old
                % route: RouteSet(1:(To+1-i1))?= OrouteV(1:(To+1-i1))
                % OrouteV is the suggested route
                flag=ismember(RouteSet(i1:(To+1)),reshape(OrouteV(1:(To+2-i1)),[1,(To+2-i1)]),'rows');
                %
                if (PCost1<(zr+zb))&(flag==0)
                    % there are two routes to be selected: the familiar/visible route
                    % and the guidance route
                    Perceive_F=zr+zb*betaB-RouteSet(d+4)*betaF;
                    Perceive_G=PCostR1+PCostB1*betaB-betaG;
                    % probabilities of selecting a route
                    Pr_route=zeros(Num_route+1,1);
                    U_routeG=exp(-Perceive_G);
                    U_routeF=exp(-Perceive_F);
                    %
                    Pr_routeG=U_routeG/(U_routeF+U_routeG);
                    Pr_routeF=U_routeF/(U_routeF+U_routeG);
                    % expected cost of the route
                    EU_setR(i)=PCostR1*Pr_routeG+zr*Pr_routeF;
                    EU_setB(i)=PCostB1*Pr_routeG+zb*Pr_routeF;
                else
                    % if there does not exist a better route (to be suggested), add (update) the cost
                    % the cost is zr and zb
                    EU_setR(i)=zr;
                    EU_setB(i)=zb;
                end
                %
            end
        end
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%% Determine the suggested route
%
ExpectUV=[];
for i=1:Num_V
    if VerS(d+1,i)==0
        break;
    else    %  VerS(d+1,:) (non-zero element)
        Destination=VerS(d+1,i);
        % generate the route
        if Destination==Num_V
            Dist=zeros(1,ke);
            for i2=1:ke
                Destination=Num_V+i2-1;
                [dist,path1,pred] = shortestpath(BGobj,Origin,Destination,'directed',false,'method','BFS');
                Dist(i2)=dist;
            end
            [c1 e1]=min(Dist);
            Destination=Num_V+e1-1;
            [dist,path1,pred] = shortestpath(BGobj,Origin,Destination,'directed',false,'method','BFS');
            path1(dist+1)=Num_V;
            Destination=Num_V;
        else
            [dist,path1,pred] = shortestpath(BGobj,Origin,Destination,'directed',false,'method','BFS');
        end
        %
        % the path to be tested: idential with a route in RouteSet?
        if dist<d
            patht=[path1 zeros(1,d-dist)];
        else
            patht=path1;
        end
        %
        % is the route suggested already in RouteSet?
        if (ismember(patht,RouteSet(:,1:(d+1)),'rows')==0)|(dist==0)
            % the route suggested is not in RouteSet
            % Jv_psyc should be derived
            Zb=PCostB(Destination);
            Zr=PCostR(Destination);
            if dist==0
                Zr=Zr+ risk(path1(dist+1),(dist+1));
            else
                for i1=1:dist
                    Zr=Zr+ risk(path1(i1),i1);
                    if path1(i1)==path1(i1+1)
                        Zb = Zb+lambdaV_t(path1(i1+1),i1+1);
                    else
                        [EdgeN flag]=EdgeF(path1(i1),path1(i1+1),C);
                        Zb = Zb+lambdaV_t(path1(i1+1),i1+1)+lambda_t(EdgeN,i1);
                    end
                end
                Zr=Zr+ risk(path1(dist+1),(dist+1));
            end
            Jt=Zb+Zr;
            Jv_psyc = Jt-betaG;
            %
            % probabilities of selecting a route
            Pr_route=zeros(Num_route+1,1);
            U_route=zeros(Num_route+1,1);
            for i2=1:Num_route
                U_route(i2)=exp(-RouteSet(i2,(d+7)));
            end
            U_route(i2+1)=exp(-Jv_psyc);
            U_sum=sum(U_route);
            for i2=1:(Num_route+1)
                Pr_route(i2)=U_route(i2)/U_sum;
            end
            %
            % the expected disutilities
            ExpectU=0;
            for i2=1:Num_route
                ExpectU=ExpectU+Pr_route(i2)*RouteSet(i2,(d+6));
            end
            ExpectU=ExpectU+Pr_route(1+Num_route)*Jt;
            %
        else
            % the route suggested is in RouteSet
            %
            % probabilities of selecting a route
            [a b]=ismember(path1,RouteSet(:,1:(dist+1)),'rows');
            Pr_route=zeros(Num_route,1);
            PreU_route=zeros(Num_route,1);
            U_route=zeros(Num_route,1);
            for i2=1:Num_route
                Pre_route(i2)=RouteSet(i2,(d+7));
            end
            Pre_route(b)=Pre_route(b)-betaG;
            for i2=1:Num_route
                U_route(i2)=exp(-Pre_route(i2));
            end
            %
            U_sum=sum(U_route);
            for i2=1:Num_route
                Pr_route(i2)=U_route(i2)/U_sum;
            end
            %
            % the expected disutilities
            ExpectU=0;
            for i2=1:Num_route
                ExpectU=ExpectU+Pr_route(i2)*(EU_setB(i2)+EU_setR(i2));
                % RouteSet(i2,(d+6));
            end
            %
        end
        ExpectUV=[ExpectUV;ExpectU];
        %
    end
end
%
% Selecting the best route (to suggest)
[Cost k1]=min(ExpectUV);
%
%%
i=k1;
Destination=VerS(d+1,i);
% generate the route
if Destination==Num_V % if the destination is out of the building 
    Dist=zeros(1,ke);
    for i2=1:ke
        Destination=Num_V+i2-1;
        [dist,path1,pred] = shortestpath(BGobj,Origin,Destination,'directed',false,'method','BFS');
        Dist(i2)=dist;
    end
    [c1 e1]=min(Dist);
    Destination=Num_V+e1-1;
    [dist,path1,pred] = shortestpath(BGobj,Origin,Destination,'directed',false,'method','BFS');
    path1(dist+1)=Num_V;
else
    [dist,path1,pred] = shortestpath(BGobj,Origin,Destination,'directed',false,'method','BFS');
end
%
% is the route suggested already in RouteSet?
if (ismember(path1,RouteSet(:,1:(dist+1)),'rows')==0)|(dist==0)
    % the route suggested is not in RouteSet
    % Jv_psyc should be derived
    Zb=PCostB(Destination);
    Zr=PCostR(Destination);
    if dist==0
        Zr=Zr+ risk(path1(dist+1),(dist+1));
    else
        for i1=1:dist
            Zr=Zr+ risk(path1(i1),i1);
            [EdgeN flag]=EdgeF(path1(i1),path1(i1+1),C);
            Zb = Zb+lambdaV_t(path1(i1+1),i1+1)+lambda_t(EdgeN,i1);
        end
        Zr=Zr+ risk(path1(dist+1),(dist+1));
    end
    Zr=Zr+ risk(path1(dist+1),(dist+1));
    Jt=Zb+Zr;
    Jv_psyc = Jt-betaG;
    %
    % probabilities of selecting a route
    Pr_route=zeros(Num_route+1,1);
    U_route=zeros(Num_route+1,1);
    for i2=1:Num_route
        U_route(i2)=exp(-RouteSet(i2,(d+7)));
    end
    U_route(i2+1)=exp(-Jv_psyc);
    U_sum=sum(U_route);
    for i2=1:(Num_route+1)
        Pr_route(i2)=U_route(i2)/U_sum;
    end
    %
    % ProbR CostSR CostSB ECostOR ECostOB
    ProbR=Pr_route(Num_route+1);
    ECostOB=0;
    ECostOR=0;
    for i2=1:Num_route
        ECostOR=ECostOR+RouteSet(i2,(d+3))*Pr_route(i2);
        ECostOB=ECostOB+RouteSet(i2,(d+2))*Pr_route(i2);
    end
    CostSR=ECostOR+Zr*Pr_route(Num_route+1);
    CostSB=ECostOB+Zb*Pr_route(Num_route+1);
    %
else
    % the route suggested is in RouteSet
    %
    % probabilities of selecting a route
    [a b]=ismember(path1,RouteSet(:,1:(dist+1)),'rows');
    Pr_route=zeros(Num_route,1);
    PreU_route=zeros(Num_route,1);
    U_route=zeros(Num_route,1);
    for i2=1:Num_route
        Pre_route(i2)=RouteSet(i2,(d+7));
    end
    Pre_route(b)=Pre_route(b)-betaG;
    for i2=1:Num_route
        U_route(i2)=exp(-Pre_route(i2));
    end
    %
    U_sum=sum(U_route);
    for i2=1:Num_route
        Pr_route(i2)=U_route(i2)/U_sum;
    end
    %
    % ProbR CostSR CostSB ECostOR ECostOB
    ProbR=Pr_route(b);
    CostSR=0;
    CostSB=0;
    for i2=1:Num_route
        CostSR=CostSR+RouteSet(i2,(d+3))*Pr_route(i2);
        CostSB=CostSB+RouteSet(i2,(d+2))*Pr_route(i2);
    end
    ECostOR=CostSR-RouteSet(b,(d+3))*Pr_route(b);
    ECostOB=CostSB-RouteSet(b,(d+2))*Pr_route(b);
    %
end
%
% the suggested route
if dist<d
    PSuggestR=[path1 zeros(1,(d-dist))];
else
    PSuggestR=path1;
end