function [routeV, pathV, CostR, CostB]=dpsolve(v_I,groupN, groupIndex,Num_oV, C, BGobj, ke,routeV, pathV, RouteInMind, To, SrouteV,EdgeV, StayC,betaG, betaH, betaF, betaB,risk,lambdaV_t,lambda_t, CapaN, p_pass, Block_f, Block_c )
% function [RouteV pathV qd PCostR]=dpsolve(v_I,groupN,risk,C,lambdaV_t,lambda_t,d, T,CapaN, p_pass,
% betaSG,betaG,betaH,Block_f, Block_c,staticG,HerdS,VisibleS,To,SrouteV,EdgeV,ExitV,ke,StayC)
%
[Num_V Num_E]=size(C);
% 
% Given: v_I,groupN, groupIndex, C, BGobj, ke, 
% Given: routeV, pathV (to be updated; full dimension) 
% Given: RouteInMind: (dimension) Num_oV*ke*(To+1+6) 
% Given: time window: To: [0,To]; 
% Given: SrouteV,  EdgeV, StayC 
% Given: betaG, betaH, betaF, betaB
% Given: risk (< 1 )
% Given: lambdaV_t,lambda_t, CapaN, p_pass, Block_f, Block_c  
%
% Output: RouteV, pathV, CostR, CostB 
%
% Terminal costs are associated with a heuristic route (?? HrouteV?)
%
% Cost about blockages at t= To+1(d+1)
PCostB=zeros(Num_V,1); 
% Cost about risks at t= To+1(d+1)
PCostR=zeros(Num_V,1); 
PCost=zeros(Num_V,1); 
%
% (Heuristic) route: (written as) vertices 
[xx T]=size(routeV);
HrouteV=zeros(Num_V,T); 
VerS=FcandiV(v_I,To,C);
for i=1:Num_V
    if VerS(To+1,i)==0
        break;
    else
        v=VerS(To+1,i);
        %[c OrouteV]=heuriA(VerS(d+1,i),Num_V,SrouteV,EdgeV,lambda,ke,r);
        % "OrouteV": Original route extended from a Vertex
        % the stay strategy has been considered in HeuriA.m 
        [cB cR OrouteV]=heuriA(v,To,Num_V,SrouteV,EdgeV,lambdaV_t,lambda_t,ke,risk,StayC);
        PCostB(v)=cB;
        PCostR(v)=cR;
        PCost(v,To+1)=cB+cR;   % Cost at t = To+1
        HrouteV(v,(To+1):T)=OrouteV(1:(T-To));  % assuming T<Num_V
    end
end
% HrouteVT=zeros(Num_V,T); 
DisutilityM=[]; % the matrix store disutilities 
%%
%
v_start=v_I;
partialCostR=0;
partialCostB=0;
SuggestR=zeros(1,(To+1));
blockTime=To;
%
for i=1:To
    if blockTime<To
        t=blockTime;
    else
        t=i-1;
    end
    % CostSR: Cost of Suggested route (risk); CostSB: Cost of Suggested route (Blockage);
    % ECostOR: Expected cost of other routes (risk);ECostOB: Expected cost of other routes (blockage);
    if v_start<Num_oV
        [PSuggestR ProbG CostSR CostSB ECostOR ECostOB]=SelectR(v_start,groupIndex,routeV,C,BGobj,ke,RouteInMind,t,To,PCostR,PCostB,betaG,betaH,betaF,betaB,risk,lambdaV_t,lambda_t,CapaN,p_pass,SrouteV, EdgeV,StayC);
    else
        % if v_start is a virtual vertex
        v_start=SuggestR(blockTime-1);
        [PSuggestR ProbG CostSR CostSB ECostOR ECostOB]=SelectR(v_start,groupIndex,routeV,C,BGobj,ke,RouteInMind,t,To,PCostR,PCostB,betaG,betaH,betaF,betaB,risk,lambdaV_t,lambda_t,CapaN,p_pass,SrouteV, EdgeV,StayC);
    end
    %    
    %% Update SuggestR 
    %
    SuggestR((t+1):(To+1))=PSuggestR;  % Partial suggested route
    % udpate disutilities information 
    % update vector [partialCost, Pr_guide, Cost_Guide, ECostOthers] into matrix
    DisutilityM=[DisutilityM;[partialCostR,partialCostB,ProbG,CostSR,CostSB,ECostOR,ECostOB]];
    %% movement and possible blockages
    %
    % is there any blocked vertex/edge on Suggested Route?
    % given SuggestR, Block_c, Block_f, p_pass
    blockTime=To;
    for i1=(t+1):To   % time window [t,To-1]: possible time of reselection
        v=SuggestR(i1+1);
        if v==0
            break;
        else
            e=EdgeF(SuggestR(i1),v,C);
            if (ismember(v,Block_c(:,(i1+1)))==1)|(ismember(v,Block_f(:,(i1+1)))==1)
                blockTime=i1-1;  % the time point of reselection (route)
                break;
            elseif p_pass(e,(i1+1))<1
                blockTime=i1-1;
                break;
            end
        end
    end
    %
    %% if blockTime < To, reselect a route
    % Reselecting a route
    if blockTime< To
        % based on "blockTime", derive cost from t to blockTime
        % the time window [t,blockTime]: [t+1,blockTime+1]
        %
        partialCostR=0;
        partialCostB=0;
        v_start=SuggestR(blockTime+1);
        for i1=(t+1):(blockTime+1)
            % partialCostR =sum(risk [t+1,blockTime+1])
            partialCostR=partialCostR+risk(SuggestR(i1),i1);
            % partialCostB =  sum(blockage [t,blockTime])
            [EdgeN flag]=EdgeF(SuggestR(i1),SuggestR(i1+1),C);
            partialCostR=partialCostR+lambdaV_t(SuggestR(i1+1),i1+1)+lambda_t(EdgeN,i1);
        end                   
    else
        break; 
    end     
end
%
%% Update expected disutilities (backwardly, CostB, CostR)
% Given DisutilityM
%     DisutilityM=[Disutility;(partialCostR,partialCostB,ProbG,CostSR,CostSB,ECostOR,ECostOB)];
%                                    1             2       3     4      5      6       7  
% Derive Expected disutility 
[SelectN col]=size(DisutilityM);
%
if SelectN>1
    for i=SelectN:2
        DisutilityM((i-1),3)=DisutilityM(i,3)*DisutilityM(i,4)+DisutilityM(i,6)+DisutilityM(i,1);
        DisutilityM((i-1),4)=DisutilityM(i,3)*DisutilityM(i,5)+DisutilityM(i,7)+DisutilityM(i,2);
    end    
end
CostR=(DisutilityM(1,3)*DisutilityM(1,4)+DisutilityM(1,6))*groupN;
CostB=(DisutilityM(1,3)*DisutilityM(1,5)+DisutilityM(1,7))*groupN;
%
%% The final suggested route: SuggestR + HeuristicR 
% 
% final result: marginal cost -> group cost 
% final result: HrouteV and E{Cost}
% HrouteV(v,(To+1):T)=OrouteV(1:(T-To));
for i=1:(To+1)
    if SuggestR(i)==0
        routeV(groupIndex,1:(i-1))= SuggestR(1:(i-1));
        routeV(groupIndex,(i-1):(i-2+T-To))=HrouteV(SuggestR(i-1),(To+1):T);
        break;
    elseif SuggestR(To+1)~=0
        routeV(groupIndex,1:(To+1))= SuggestR(1:(To+1));
        routeV(groupIndex,(To+1):T)=HrouteV(SuggestR(To+1),(To+1):T);
        break;
    end
end
pathV(groupIndex,:)=Gpath(routeV(groupIndex,:),C);