%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Fire Prediction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function result=fire_prediction(Ft1, T, FireP)
% Predicting fire propagation
% Initial fire status is given by Ft1
% Time horizon: [1, T]
% Conditional probability given by FireP
%
m=size(Ft1,1);
result=zeros(m, T);
result(:,1)=Ft1;
for i=2:T
    for j=1:m
        temp=1;
        for k=1:m
            temp=temp*(1-FireP(j,k)*result(k,i-1));
        end
        result(j,i)=1-temp;
    end
end