% calculate the best route in Heuristic Algorithm, return: cost and route
% add q_t: the absolute penalty in SAVLR 
function [cB cR OrouteV]=heuriA(v,d,Num_V,SrouteV,EdgeV,lambdaV_t,lambda_t,ke,risk,StayC,q_t,ck)
% lambdaV(vertex, time): missing???
% lambdaE(edge, time)
% R(vertex, time): risk ?? dimension correct? (not times people's number)
[xx,T]=size(lambdaV_t);
if v==Num_V
    % if the terminal vertex is outside the building
    cB=0;
    cR=0;
    OrouteV=zeros(1,Num_V);
    OrouteV(1)=Num_V;
else
    % Retrieve Terminal route: SrouteV(i,index of exit,:)
    % calculate the terminal costs for each route to an exit, select
    CostVB=zeros(1,ke);
    CostVR=zeros(1,ke);
    CostV=zeros(1,ke);
    for i1=1:ke
        route=SrouteV(v,i1,:);
        edge=EdgeV(v,i1,:);
        CostR=0;
        CostB=0;
        % calculate marginal cost (per person): original CostHeu.m 
        l=length(route);
        for i2=1:l
            if route(i2+1)==0
                break;
            else
                v1=route(i2+1);
                e1=edge(i2);
                if (i2+d+1)<=T
                    % risk value related to fire, time step: i2+d
                    CostR=CostR+risk(v1,(i2+d+1));
                    % Lambda value (Room capacity), time step: i2+d
                    CostB=CostB+lambdaV_t(v1,(i2+d+1));
                    e1=edge(i2);
                    % Lambda value (Passage capacity), time step: i2+d-1
                    CostB=CostB+lambda_t(e1,(i2+d))+q_t(e1,(i2+d))*ck/2;
                end
            end
        end
        %
        CostVB(i1)=CostB;
        CostVR(i1)=CostR;
        CostV(i1)=CostR+CostB;
    end
    [c I]=min(CostV);   % c is minimum value, I is the index in the vector (CostV)
    OrouteV=SrouteV(v,I,:);
    cB=CostVB(I);
    cR=CostVR(I);
    %
    CostS=StayC(v); % ????? R is the risk , Assigned value for v2
    % guidance derived (one vertex and one edge) and the expected cost derived
    if CostS<c % if staying is the preferred strategy
        cR=CostS;
        cB=0;
        OrouteV=zeros(1,Num_V);
        OrouteV(1)=v;
    end    
end